var player : int;
var canMove : boolean;
var speed : float;
var maxspeed : float;

var shots : int;
var bombs : int;
var time : float;
var nextfire : float;
var firerate : float;

var cupcake : GameObject;
var hitbox : GameObject;
var text : GameObject;
var pivot : GameObject;
var tracker : GameObject;
var blood : GameObject;
var bloodpoint : GameObject;
var smoke : GameObject;
var candy : GameObject;
var hit : GameObject;
var running : GameObject;
var textmes : GameObject;
var sparkles : GameObject;

var color : Color[];

var red : Texture;
var green : Texture;

var rainbow : TrailRenderer;
var powerid : int;
var powertime : float;
var once : boolean;
var stolen : boolean;

var muzzle : GameObject;
var laser : GameObject;

private var invincible : boolean = true;
private var invinctimer : float;

var attacking : boolean;
var moving : boolean;
var haspowerup : boolean;
var audioone : boolean;

var attack : AudioClip;
var pickup : AudioClip;
var messdate : AudioClip;
var reflect : AudioClip;
var lasers : AudioClip;
var bomb : AudioClip;
var die : AudioClip;
var boost : AudioClip;

var models : GameObject[];
var num : int;

function Start(){
	if(player == 2){
		models[0].gameObject.renderer.materials[1].mainTexture = red;
	}
	if(player == 3){
		num = 1;
	}
	if(player == 4){
		models[1].gameObject.renderer.materials[1].mainTexture = green;
		num = 1;
	}

	text.GetComponent("TextMesh").text = "P" + player;
	rainbow.enabled = false;
	laser.gameObject.active = false;
	muzzle.gameObject.active = false;
	laser.gameObject.name = player.ToString();
	transform.renderer.material.color = color[player-1];
	Flash();

	for(var i : int = 0; i < 2; i++){
		models[i].gameObject.SetActiveRecursively(false);
	}
	models[num].gameObject.SetActiveRecursively(true);

	yield WaitForSeconds(1.5);
	invincible = false;
}

function FixedUpdate(){
	if(moving == false){
		rigidbody.angularVelocity = rigidbody.angularVelocity * 0.9;
	}
}

function Update () {
	pivot.transform.eulerAngles = Vector3(0,0,0);

	if(haspowerup == true){
		rainbow.enabled = true;
		sparkles.gameObject.active = true;
	}else{
		rainbow.enabled = false;
		sparkles.gameObject.active = false;
	}

	if(stolen == true){
		stolen = false;
		Message("stolen");
	}

	if(haspowerup == true){
		if(once == false){
			once = true;
			powerid = Random.Range(0,3);

			if(powerid == 0){
				shots = 3;
				Message("laser");
			}
			if(powerid == 1){
				Message("boost");
			}
			if(powerid == 2){
				bombs = 3;
				Message("bombs");
				audio.PlayOneShot(boost);
			}
		}
		powertime += Time.deltaTime;

		if(powertime > 3){
			speed = 25;
			powertime = 0;
			haspowerup = false;
		}
		if(powerid == 1){
			speed = 50;
		}
	}else{
		once = false;

	}

	//get rotation
	var direction = new Vector3(-Input.GetAxis("LHorizontal" + player),0,Input.GetAxis("LVertical" + player));
	var rotation = Quaternion.LookRotation(direction,Vector3.up);

	//walk forward
	if(direction.magnitude > 0.4f && canMove == true){	
		smoke.gameObject.active = true;
		moving = true;
		transform.Translate(0, 0, -Time.deltaTime * speed, transform);
	}else{
		transform.Translate(0, 0, -Time.deltaTime * speed, transform);
		moving = false;
	}

	if(direction.magnitude > 0.4f && Spawner.paused == false){
		transform.rotation = rotation;
	}


	var hit : RaycastHit;
	if(Physics.Raycast(transform.position, transform.forward, hit, 1.5)){
		if(hit.collider.tag == "Player"){
			if(audioone == false){
				audioone = true;
				AudioCD();
				audio.PlayOneShot(reflect);
			}
			Hit();
			tracker.transform.LookAt(hit.collider.transform);
			rigidbody.velocity = -tracker.transform.forward * 50;
			Spawner.shake = true;
		}
	}


	if(Physics.Raycast(transform.position, Vector3.forward, hit, 1.5)){		//up
		if(hit.collider.tag == "Wall"){
			transform.position.z = hit.transform.position.z - 2;
		}
	}
	if(Physics.Raycast(transform.position, -Vector3.forward, hit, 1.5)){	//down
		if(hit.collider.tag == "Wall"){
			transform.position.z = hit.transform.position.z + 2;
		}
	}
	if(Physics.Raycast(transform.position, -Vector3.left, hit, 1.5)){		//right
		if(hit.collider.tag == "Wall"){
			transform.position.x = hit.transform.position.x - 2;
		}
	}
	if(Physics.Raycast(transform.position, Vector3.left, hit, 1.5)){		//left
		if(hit.collider.tag == "Wall"){
			transform.position.x = hit.transform.position.x + 2;
		}
	}

	if(moving == true){
		if(speed < maxspeed){
			if(speed < 15){
				running.gameObject.active = true;
			}else{
				running.gameObject.active = false;
			}

			speed += Time.deltaTime*20;
		}else{
			if(haspowerup == false){
				speed = 25;
			}
		}
	}else{
		if(speed > 0){
			speed -= Time.deltaTime*20;
		}else{
			speed = 0;
			smoke.gameObject.active = false;
			running.gameObject.active = false;
		}
	}

	//attack
	if(Input.GetButton("ButtonA" + player) && Time.time > nextfire){
		if(shots > 0){
			audio.PlayOneShot(lasers);
			attacking = true;
			nextfire = Time.time + firerate;
			shots --;
			Shoot();
		}
		if(bombs > 0){
			audio.PlayOneShot(bomb);
			attacking = true;
			nextfire = Time.time + firerate;
			bombs --;
			Bombs();
		}
		if(shots == 0 && bombs == 0){
			audio.PlayOneShot(attack);
			attacking = true;
			nextfire = Time.time + firerate;
			var hitobj : GameObject = Instantiate(hitbox,transform.position,transform.rotation);
			hitobj.gameObject.name = player.ToString();
			hitobj.transform.parent = transform;
			Physics.IgnoreCollision(hitobj.collider,transform.collider);
			hitobj.rigidbody.velocity = -transform.forward * 50;
			rigidbody.velocity = -transform.forward * 50;
			Cooldown();
		}
	}
}

function OnCollisionEnter(col : Collision){
	if(col.collider.tag == "Sword"){
		if(invincible == false){
			if(attacking == true){
				Hit();
				audio.PlayOneShot(reflect);
				tracker.transform.LookAt(col.transform);
				rigidbody.velocity = -tracker.transform.forward * 50;
				Spawner.shake = true;
			}else{
				if(shots > 0){
					col.transform.parent.GetComponent("Player").shots = shots;
					col.transform.parent.GetComponent("Player").stolen = true;
				}
				if(bombs > 0){
					col.transform.parent.GetComponent("Player").bombs = bombs;
					col.transform.parent.GetComponent("Player").stolen = true;
				}
				audio.PlayOneShot(die);
				Die();
				var id : int = int.Parse(col.gameObject.name.ToString());
				Spawner.kills[id-1] ++;
				Destroy(gameObject);
			}
		}
	}
}

function Cooldown(){
	yield WaitForSeconds(0.1);
	attacking = false;
}

function Shoot(){
	muzzle.gameObject.active = true;
	laser.gameObject.active = true;
	Spawner.shake = true;
	rigidbody.velocity = transform.forward * 30;
	yield WaitForSeconds(0.3);
	muzzle.gameObject.active = false;
	laser.gameObject.active = false;
	attacking = false;
}

function Bombs(){
	var bombobj : GameObject = Instantiate(cupcake, transform.position, transform.rotation);
	Physics.IgnoreCollision(bombobj.collider,transform.collider);
	bombobj.gameObject.name = player.ToString();
	//bombobj.rigidbody.velocity = -transform.forward * 35;
	yield WaitForSeconds(0.3);
	attacking = false;
}

function Hit(){
	//Instantiate(hit, transform.position,transform.rotation);
	canMove = false;
	yield WaitForSeconds(0.2);
	rigidbody.velocity = Vector3(0,0,0);
	canMove = true;
}

function Die(){
	Spawner.killamount ++;
	audio.PlayOneShot(die);
	Instantiate(hit, transform.position,transform.rotation);
	var bloodobj : GameObject = Instantiate(blood, transform.position,transform.rotation);
	bloodobj.transform.eulerAngles.y = Random.Range(0,360);
	var candyobj : GameObject = Instantiate(candy, transform.position,transform.rotation);
	candyobj.transform.eulerAngles = Vector3(-90,0,0);
}

function Flash(){
	for(var i : int = 0; i < 3; i++){
		yield WaitForSeconds(0.25);
		transform.renderer.material.color = Color.white;
		yield WaitForSeconds(0.25);
		transform.renderer.material.color = color[player-1];
	}
}

function Message(message : String){
	var textobj : GameObject = Instantiate(textmes, transform.position, transform.rotation);
	textobj.transform.position.y = 3;
	textobj.transform.parent = transform;
	textobj.GetComponent("TextMesh").text = message;
}

function AudioCD(){
	yield WaitForSeconds(0.1);
	audioone = false;
}