var playing : boolean[];
var playeramount : int;
var players : GameObject[];
var player : GameObject;
var cam : GameObject;

var powerup : GameObject;
var powerhold : GameObject;
var nextpower : float;
var powerrate : float;

var shakeamount : Vector2;

var pos : Vector3;

var state : int;
var character : int[];

var controller : Texture;
var pause : Texture;
var pausetime : float;

var killsave : int;
var killtime : float;
var gametime : float;

static var killamount : int;
static var kills : int[];
static var shake : boolean;
static var end : boolean;
static var paused : boolean;
private var once : boolean;
private var onetimer : float;
var shaketime : float;

var green : Material;
var red : Material;

var areyousure : boolean;
var spawning : boolean = true;
var winner : int;

var click : AudioClip;
var scroll : AudioClip;
var start : AudioClip;
var join : AudioClip;
var quit : AudioClip;
var kill : AudioClip;
var victory : AudioClip;

var playerframe : Texture[];
var clickframe : Texture[];

var mystyle : GUIStyle;

var victoryscreen : GameObject;
var victorys : Texture[];

function Start () {
	victoryscreen.gameObject.renderer.enabled = false;
	kills = new int[4];
	cam.transform.position = pos;
	nextpower = Random.Range(7,15);

	yield WaitForSeconds(2);
	invincible = false;
}

function Update () {
	if(shake == true){
		shaketime += Time.deltaTime;

		cam.transform.position.x = cam.transform.position.x + Random.Range(-shakeamount.x,shakeamount.x);
		cam.transform.position.z = cam.transform.position.z + Random.Range(-shakeamount.y,shakeamount.y);

		if(shaketime > 0.2){
			cam.transform.position = pos;
			shaketime = 0;
			shake = false;
		}
	}
	cam.transform.eulerAngles.y = Mathf.Sin(Time.time*2);

	gametime = Time.timeScale;

	if(killamount > killsave){
		audio.PlayOneShot(kill);
		killsave = killamount;
		Time.timeScale = 0.1;
	}
	if(Time.timeScale < 1){
		Time.timeScale += Time.deltaTime * 4;
	}else{
		if(paused == false){
			Time.timeScale = 1;
		}
	}

	for(var k : int = 0; k < kills.length; k++){
		if(kills[k] == 10){
			if(end == false){
				audio.PlayOneShot(victory);
			}
			winner = k;
			end = true;
		}
	}

	//character joining
	if(state == 0){
		for(var e : int = 1; e < players.length+1; e++){
			if(Input.GetButtonDown("ButtonA" + e) && playing[e-1] == false){
				audio.PlayOneShot(join);
				playeramount ++;
				playing[e-1] = true;
			}
			if(playing[e-1] == true && Input.GetAxis("LVertical" + e) == -1){	//up
				if(character[e-1] < 1 && once == false){
					audio.PlayOneShot(scroll);
					character[e-1] ++;
					once = true;
					onetimer = 0;
				}
			}else{
				onetimer += Time.deltaTime;
				if(onetimer > 0.5){
					once = false;
				}
			}
			if(playing[e-1] == true && Input.GetAxis("LVertical" + e) == 1){	//down
				if(character[e-1] > 0 && once == false){
					audio.PlayOneShot(scroll);
					character[e-1] --;
					once = true;
					onetimer = 0;
				}
			}else{
				onetimer += Time.deltaTime;
				if(onetimer > 1){
					once = false;
				}
			}

			if(Input.GetButtonDown("ButtonB" + e) && playing[e-1] == true){
				audio.PlayOneShot(quit);
				playeramount --;
				playing[e-1] = false;
			}
			if(Input.GetButtonDown("Start" + e)){
				if(playeramount > 0){
					audio.PlayOneShot(start);
					players = new GameObject[4];
					state = 1;
				}
			}
		}
	}

	//character spawning
	if(state == 1){
		for(var i : int = 0; i < players.length; i++){
			if(players[i] == null && playing[i] == true){
				players[i] = Instantiate(player);
				players[i].GetComponent("Player").player = i+1;
				players[i].GetComponent("Player").num = character[i];
				players[i].transform.position.x = Random.Range(-20,20);
				players[i].transform.position.z = Random.Range(-20,20);
				shake = true;
			}
		}
		if(powerhold == null && Time.time > nextpower){
			nextpower = Time.time + Random.Range(7,15);
			powerhold = Instantiate(powerup, transform.position, transform.rotation);
			powerhold.transform.position.x = Random.Range(-17,17);
			powerhold.transform.position.z = Random.Range(-17,17);
		}

		pausetime += Time.deltaTime;
		for(var j : int = 1; j < players.length +1; j++){
			if(Input.GetButtonDown("Start" + j) && pausetime > 0.25){
				paused = !paused;

				if(paused == true){
					Time.timeScale = 0;
				}else{
					Time.timeScale = 1;
				}
			}
			if(Input.GetButton("Back" + j)){
				areyousure = true;
				Time.timeScale = 0;
			}
			if(areyousure == true){
				if(Input.GetButtonDown("ButtonY" + j)){
					Application.LoadLevel("Game");
					Time.timeScale = 1;
					end = false;
				}
				if(Input.GetButtonDown("ButtonB" + j)){
					areyousure = false;
					Time.timeScale = 1;
					end = false;
				}
			}
		}
	}
}

function OnGUI(){
	if(areyousure == true){
		GUI.Label(Rect(Screen.width/2-150 ,Screen.height/2+200,200,200), "Are you sure Y/B?", mystyle);
	}

	if(state == 0){
		GUI.Label(Rect(Screen.width/2-150 ,20,200,200), "press A to join", mystyle);

		for(var e : int = 0; e < players.length; e++){
			if(character[e] == 0){
				GUI.DrawTexture(Rect(250 + 275*e , Screen.height/2-250, 350, 500), playerframe[e], ScaleMode.ScaleToFit, true, 0f);
			}


			if(playing[e] == true){
				GUI.DrawTexture(Rect(250 + 275*e , Screen.height/2-250, 350, 500), clickframe[e], ScaleMode.ScaleToFit, true, 0f);
				//GUI.Label(Rect(415 + 275*e ,Screen.height/2+75,50,100), character[e].ToString(), mystyle);
			}
			GUI.DrawTexture(Rect(350 + 275*e, Screen.height/2+150 + (Mathf.Sin(Time.time*5)*10),150,150), controller, ScaleMode.ScaleToFit, true, 0f);
		}
	}

	if(state == 1){
		for(var i : int = 0; i < players.length; i++){
			if(playing[i] == true){
				GUI.Label(Rect(500 + 200*i ,10,25,100), kills[i].ToString(), mystyle);
			}
		}
		if(paused == true){
			GUI.DrawTexture(Rect(Screen.width/2-75, Screen.height/2-150,150,150), pause, ScaleMode.ScaleToFit, true, 0f);
		}
	}
	if(end == true){
		GUI.Label(Rect(Screen.width/2-80 ,Screen.height/2+100,200,200), "You cruel monster", mystyle);
		victoryscreen.gameObject.renderer.enabled = true;
		if(winner == 0){
			victoryscreen.gameObject.renderer.material.mainTexture = victorys[winner];
		}
		if(winner == 1){
			victoryscreen.gameObject.renderer.material.mainTexture = victorys[winner];
		}
		if(winner == 2){
			victoryscreen.gameObject.renderer.material.mainTexture = victorys[winner];
		}
		if(winner == 3){
			victoryscreen.gameObject.renderer.material.mainTexture = victorys[winner];
		}
		//GUI.Label(Rect(Screen.width/2-100 ,Screen.height/2-160,200,200), "Player " + actualwinner + " is the winner", mystyle);
	}
}